// Penn Parallel Primitives Library
// Author: Prof. Milo Martin
// University of Pennsylvania
// Spring 2010

#include "QueueLock.h"

namespace ppp {

  // These functions are use to wrap the thread-local variable, because
  // some linking errors were occurring sporadically when it was
  // included in the header file.  This seems to fix the problem at the
  // cost of a function call overhead.

  __thread node_t* t_local_node = NULL;

  node_t* get_local_node() { return t_local_node; }
  void set_local_node(node_t* n) { t_local_node = n; }

}
