// Penn Parallel Primitives Library
// Author: Prof. Milo Martin
// University of Pennsylvania
// Spring 2010

#include <stdio.h>

#include "ppp.h"
#include "atomic.h"
#include "barrier.h"
#include "random.h"
#include "TTSLock.h"

ppp::atomic<int> counter;

ppp::TTSLock l;
volatile int counter2;

void start()
{
  ppp::barrier();
  for (int i = 0; i<1000000; i++) {
    //    uint32_t r = ppp::threadsafe_random();
    //    l.acquire();
    //    counter2++;
    //    l.release();
    //counter.set(counter.get() + 1);
    //counter.fetch_and_inc();
    //    ppp::barrier();
  }
  uint32_t q = ppp::threadsafe_random();
  printf("%d %d\n", ppp::get_thread_id(), q % 1000);

  //  printf("hello world: %d of %d\n", ppp::get_thread_id(), ppp::get_thread_count());
}

int main()
{
  ppp::init(start, 10);
  printf("%d\n", counter2);

  return 0;
}

