// Penn Parallel Primitives Library
// Author: Prof. Milo Martin
// University of Pennsylvania
// Spring 2010

#ifndef PPP_ARRAYLOCK_H
#define PPP_ARRAYLOCK_H

#include "atomic.h"

namespace ppp {
  
  namespace {
    enum LockStatus { 
      LockStatus_MustWait = 0, 
      LockStatus_GoAhead = 1 
    };
  }

  class ArrayLock {
  public:
    ArrayLock() { /* FIXME */ }

    void acquire() {
      /* FIXME */
    }
    
    void release() {
      /* FIXME */
    }

  private:
    atomic<uint64_t> m_next_slot;
    atomic<LockStatus> m_array[MAX_THREADS];
  };
}

#endif



